extern __imp_Assemble:QWORD
Assemble TEXTEQU <__imp_Assemble>
extern __imp_AssembleEx:QWORD
AssembleEx TEXTEQU <__imp_AssembleEx>
extern __imp_Disassemble:QWORD
Disassemble TEXTEQU <__imp_Disassemble>
extern __imp_DsmVersion:QWORD
DsmVersion TEXTEQU <__imp_DsmVersion>
extern __imp_FreeInstr:QWORD
FreeInstr TEXTEQU <__imp_FreeInstr>
extern __imp_InitInstr:QWORD
InitInstr TEXTEQU <__imp_InitInstr>
extern __imp_InstrDasm:QWORD
InstrDasm TEXTEQU <__imp_InstrDasm>
extern __imp_InstrEF:QWORD
InstrEF TEXTEQU <__imp_InstrEF>
extern __imp_JoinMnemonic:QWORD
JoinMnemonic TEXTEQU <__imp_JoinMnemonic>
extern __imp_ReinitInstr:QWORD
ReinitInstr TEXTEQU <__imp_ReinitInstr>
extern __imp_SetCPointer:QWORD
SetCPointer TEXTEQU <__imp_SetCPointer>

VERBOSE_PFX equ 1
INVALID_INSTRUCTION equ 2
INVALID_OPERAND equ 3
OPCODE_OUT_RANGE equ 4
UNKNOWN_MNEMONIC equ 5
ASM_DUMP equ 6
NOT_ALLOWED_LOCK equ 7
NOT_ALLOWED_REP equ 8
NOT_ALLOWED_REPXX equ 9
TOO_LONG_STR equ 10
TOO_MANY_ARGS equ 11
INSUFFICIENT_BUFFER equ 12
INVALID_IN_LM16 equ 13
FULL_OPCSIZE equ 32
STD_MNEM_SIZE equ 32
STD_OPERMNEM_SIZE equ 64

MNEM_HEAP	equ 1 shl 0
OPER1_HEAP	equ 1 shl 1
OPER2_HEAP	equ 1 shl 2
OPER3_HEAP	equ 1 shl 3
OPER4_HEAP	equ 1 shl 4
OPER5_HEAP	equ 1 shl 5
MO_RANGES	equ 1 shl 6

;Modes
LONG_MODE equ 0		;abbr. LM
LEGACY_MODE32 equ 1	;abbr. LM32
LEGACY_MODE16 equ 2	;abbr. LM16

;Opcodes flags
OPER66OVER				equ 1 shl 0
ADDR67OVER				equ 1 shl 1
LOCK_PFX				equ 1 shl 2
MODRM					equ 1 shl 3
SIB_BYTE				equ 1 shl 4
MOFFSET					equ 1 shl 5
RIP_ADDR				equ 1 shl 6
ERASE_SECOND_N				equ 1 shl 7
JADDR16_BUT_NOT_LM16			equ 1 shl 8
MOD11_OPCODE				equ 1 shl 9
JADDR					equ 1 shl 11
OPER2_MEM				equ 1 shl 12
REG_OPCODE				equ 1 shl 13
RMEM_OPCODE				equ 1 shl 14
F2F366_OPCODE				equ 1 shl 15
F2F3_OPCODE				equ 1 shl 16
IS_EXIST				equ 1 shl 17
FLAG_0F					equ 1 shl 18
OPSZ_NOT_INFERRS			equ 1 shl 19
CS_D_NA					equ 1 shl 20
FLAG_38					equ 1 shl 21
FLAG_3A					equ 1 shl 22
CPL3_ALLOWED				equ 1 shl 23

;dwFlags
OFFSETS_COL equ 1 shl 0
HEX_COL equ 1 shl 1
RIP_ADDRS equ 1 shl 2
REL_ADDRS equ 1 shl 3
CR_LF equ 1 shl 4
STD_MNEM equ CR_LF or OFFSETS_COL or HEX_COL
RIP_REL equ RIP_ADDRS or REL_ADDRS or CR_LF

NA equ 0
_0 equ 1
_1 equ 2
U equ 3
_Mod equ 4
TMod equ 5
_Pop equ 6
TPop equ 7
Tst equ 8
lAH equ 9
VMS0 equ 10
VMIN equ 11
VMEN equ 12

lmem equ 1
_rng equ 2
_ovs equ 3
v0q equ 4
v1q equ 5
v2q equ 6
fpri equ 7
rnup equ 8
fexm equ 9
_ous equ 10
cmp0 equ 11
ex00 equ 12
ex01 equ 13
ex02 equ 14
ex03 equ 15

EF struc
	ID		BYTE ?	;21
	VIP		BYTE ?	;20
	VIF		BYTE ?	;19
	AC		BYTE ?	;18
	VM		BYTE ?	;17
	RF		BYTE ?	;16
	NT		BYTE ?	;14
	IOPL	BYTE ?	;13-12
	_OF		BYTE ?	;11
	_DF		BYTE ?	;10
	_IF		BYTE ?	;9
	TF		BYTE ?	;8
	SF		BYTE ?	;7
	ZF		BYTE ?	;6
	AF		BYTE ?	;4
	PF		BYTE ?	;2
	CF		BYTE ?	;0
EF ends
x87c struc
	C0	BYTE ?
	C1	BYTE ?
	C2	BYTE ?
	C3	BYTE ?
	dC0	BYTE ?
	dC1	BYTE ?
	dC2	BYTE ?
	dC3	BYTE ?
x87c ends
moRange struc
	HighAddr	DWORD ?
	LowAddr		DWORD ?
moRange ends
moRanges struc
	CntRange	ULONG ?
	rng			moRange {}
moRanges ends
pmoRanges	TYPEDEF PTR moRanges
Features struc
	Note		BYTE ?
	exNote		BYTE ?
	MnemOrd		WORD ?
	FirstOper	BYTE ?
	SecondOper	BYTE ?
	ThirdOper	BYTE ?
	FourthOper	BYTE ?
	FifthOper   BYTE ?
	iSet		BYTE ?
Features ends
Instruction struc
	CodePtr			PVOID ?	;in/out 0
	NextPtr			PVOID ? ;in/out +8
	AlterBase		QWORD ? ;in/out +16
	MnemOperType	LPSTR ? ;out +24
	Mnemonic		LPSTR ? ;out +32
	Oper1Mnemonic	LPSTR ? ;+40
	Oper2Mnemonic	LPSTR ? ;+48
	Oper3Mnemonic	LPSTR ?
	Oper4Mnemonic	LPSTR ?
	Oper5Mnemonic	LPSTR ?
	RemnCode		ULONG64 ? ;in/out
	ModrmOffsets	PVOID ?
	DsmCtrl			DWORD ?
	Mode			BYTE ?  ;in
	IsHeapStr		BYTE ?	
	FullOpcode		BYTE FULL_OPCSIZE dup(?)
	;Legacy prefixes
	SegOver			BYTE ? ;out
	RepPfx			BYTE ? ;out
	PfxCnt			BYTE ? ;out
	;REX prefix
	RexPfx			BYTE ? ;out
	InstrLen		BYTE ? ;out
	;ModRM
	mode			BYTE ? ;out
	reg				BYTE ? ;out
	rmem			BYTE ? ;out
	;SIB
	Scale			BYTE ? ;out
	Index			BYTE ? ;out
	Base			BYTE ? ;out
	ModRmAddress	BYTE 32 dup(?)
	mOffset			DWORD ? ;out
	DefaultOperSize	BYTE ? ;out
	OpFeatures		Features <>
	iFlags			PVOID ?
	x87Condition	x87c <>
	iMxcsr			DWORD ?
	DataSegMnem		DWORD ? ;out
	Status			DWORD ?
	AddrBias		DWORD ? ;out
	Opflags			DWORD ? ;out	
	DefaultAddrSize	BYTE ? ;out
	OpcNum			BYTE ?
	OpcTotal		BYTE ?
	RipOffset		BYTE 24 dup(?)
	JAddrOffset		BYTE 25 dup(?)
Instruction ends
HINSTR TYPEDEF PTR Instruction

idm macro String:VARARG
LOCAL ParmLen1,DefStr
%	FOR parm,<String>
		DefStr CATSTR <id_&parm>,< equ >,@CatStr(%MnemCnt)
		%DefStr
		MnemCnt=MnemCnt+1
	ENDM
endm

MnemCnt=0
;MnemonicsIds
idm add,push,pop,or,adc,sbb,and,daa								;  0,  1,  2,  3,  4,  5,  6,  7
idm sub,das,xor,aaa,cmp,aas,inc,dec								;  8,  9, 10, 11, 12, 13, 14, 15
idm pushad,pusha,popad,popa,bound,movsxd,arpl,imul     			; 16, 17, 18, 19, 20, 21, 22, 23
idm insb,insd,insw,outsb,outsd,outsw,jo,jno						; 24, 25, 26, 27, 28, 29, 30, 31
idm jb,jnb,jz,jnz,jbe,ja,js,jns									; 32, 33, 34, 35, 36, 37, 38, 39
idm jp,jnp,jl,jnl,jle,jg,test,xchg								; 40, 41, 42, 43, 44, 45, 46, 47
idm mov,lea,nop,pause,cdqe,cwde,cbw,cqo							; 48, 49, 50, 51, 52, 53, 54, 55
idm cdq,cwd,call,wait,pushfq,pushfd,pushf,popfq					; 56, 57, 58, 59, 60, 61, 62, 63
idm popfd,popf,sahf,lahf,movsb,movsq,movsd,movsw				; 64, 65, 66, 67, 68, 69, 70, 71
idm cmpsb,cmpsq,cmpsd,cmpsw,stosb,stosq,stosd,stosw				; 72, 73, 74, 75, 76, 77, 78, 79
idm lodsb,lodsq,lodsd,lodsw,scasb,scasq,scasd,scasw				; 80, 81, 82, 83, 84, 85, 86, 87
idm retn,les,lds,enter,leave,retf,int3,int						; 88, 89, 90, 91, 92, 93, 94, 95
idm into,iretq,iretd,iret,aam,aad,salc,xlat						; 96, 97, 98, 99,100,101,102,103
idm loopz,loopzd,loopzw,jrcxz,jecxz,jcxz,in,out					;104,105,106,107,108,109,110,111
idm jmp,int1,hlt,cmc,clc,stc,cli,sti							;112,113,114,115,116,117,118,119
idm cld,std,movs,rol,ror,rcl,rcr,shl							;120,121,122,123,124,125,126,127
idm shr,sal,sar,not,neg,mul,div,idiv							;128,129,130,131,132,133,134,135
idm sldt,str,lldt,ltr,verr,verw,sgdt,sidt						;136,137,138,139,140,141,142,143
idm lgdt,lidt,smsw,lmsw,invlpg,swapgs,rdtscp,vmrun				;144,145,146,147,148,149,150,151
idm vmmcall,vmload,vmsave,stgi,clgi,skinit,invlpga,monitor		;152,153,154,155,156,157,158,159
idm mwait,lfence,mfence,sfence,bt,bts,btr,btc					;160,161,162,163,164,165,166,167
idm cmpxchg16b,cmpxchg8b,psrlw,psraw,psllw,psrld,psrad,pslld	;168,169,170,171,172,173,174,175
idm psrlq,psllq,psrldq,pslldq,fxsave64,fxsave,ldmxcsr,stmxcsr	;176,177,178,179,180,181,182,183
idm clflush,prefetchnta,prefetcht0,prefetcht1,prefetcht2,extrq,prefetch,lar	;184,185,186,187,188,189,190,191
idm lsl,syscall,clts,sysret,invd,wbinvd,ud2,femms				;192,193,194,195,196,197,198,199
idm movups,movss,movupd,movlps,movhlps,movsldup,movlpd,movddup	;200,201,202,203,204,205,206,207
idm unpcklps,unpcklpd,unpckhps,unpckhpd,movhps,movlhps,movshdup,movhpd ;208,209,210,211,212,213,214,215
idm movaps,movapd,cvtpi2ps,cvtsi2ss,cvtpi2pd,cvtsi2sd,movntps,movntss  ;216,217,218,219,220,221,222,223
idm movntpd,movntsd,cvttps2pi,cvttss2si,cvttpd2pi,cvttsd2si,cvtps2pi,cvtss2si	;224,225,226,227,228,229,230,231
idm cvtpd2pi,cvtsd2si,ucomiss,ucomisd,comiss,comisd,wrmsr,rdtsc		;232,233,234,235,236,237,238,239
idm rdmsr,rdpmc,sysenter,sysexit,cmovo,cmovno,cmovb,cmovnb		;240,241,242,243,244,245,246,247
idm cmovz,cmovnz,cmovbe,cmova,cmovs,cmovns,cmovp,cmovnp			;248,249,250,251,252,253,254,255
idm cmovl,cmovnl,cmovle,cmovg,movmskps,movmskpd,sqrtps,sqrtss	;256,257,258,259,260,261,262,263
idm sqrtpd,sqrtsd,rsqrtps,rsqrtss,rcpps,rcpss,andps,andpd		;264,265,266,267,268,269,270,271
idm andnps,andnpd,orps,orpd,xorps,xorpd,addps,addss				;272,273,274,275,276,277,278,279
idm addpd,addsd,mulps,mulss,mulpd,mulsd,cvtps2pd,cvtss2sd		;280,281,282,283,284,285,286,287
idm cvtpd2ps,cvtsd2ss,cvtdq2ps,cvttps2dq,cvtps2dq,subps,subss,subpd	;288,289,290,291,292,293,294,295
idm subsd,minps,minss,minpd,minsd,divps,divss,divpd				;296,297,298,299,300,301,302,303
idm divsd,maxps,maxss,maxpd,maxsd,punpcklbw,punpcklwd,punpckldq		;304,305,306,307,308,309,310,311
idm packsswb,pcmpgtb,pcmpgtw,pcmpgtd,packuswb,punpckhbw,punpckhwd,punpckhdq	;312,313,314,315,316,317,318,319
idm packssdw,punpcklqdq,punpckhqdq,movd,movq,movdqu,movdqa,pshufw	;320,321,322,323,324,325,326,327
idm pshufhw,pshufd,pshuflw,pcmpeqb,pcmpeqw,pcmpeqd,emms,insertq		;328,329,330,331,332,333,334,335
idm haddpd,haddps,hsubpd,hsubps,seto,setno,setb,setnb 				;336,337,338,339,340,341,342,343
idm setz,setnz,setbe,seta,sets,setns,setp,setnp						;344,345,346,347,348,349,350,351
idm setl,setnl,setle,setg,cpuid,shld,rsm,shrd						;352,353,354,355,356,357,358,359
idm cmpxchg,lss,lfs,lgs,movzx,popcnt,bsf,bsr						;360,361,362,363,364,365,366,367
idm lzcnt,movsx,xadd,cmpps,cmpss,cmppd,movnti,pinsrw				;368,369,370,371,372,373,374,375
idm pextrw,shufps,shufpd,bswap,addsubpd,addsubps,paddq,pmullw		;376,377,378,379,380,381,382,383
idm movq2dq,movdq2q,pmovmskb,psubusb,psubusw,pminub,pand,paddusb	;384,385,386,387,388,389,390,391
idm paddusw,pmaxub,pandn,pavgb,pavgw,pmulhuw,pmulhw,cvtdq2pd		;392,393,394,395,396,397,398,399
idm cvttpd2dq,cvtpd2dq,movntq,movntdq,psubsb,psubsw,pminsw,por		;400,401,402,403,404,405,406,407
idm paddsb,paddsw,pmaxsw,pxor,lddqu,pmuludq,pmaddwd,psadbw			;408,409,410,411,412,413,414,415
idm maskmovq,maskmovdqu,psubb,psubw,psubd,psubq,paddb,paddw			;416,417,418,419,420,421,422,423
idm paddd,pfcmpge,pfmin,pfrcp,pfrsqrt,pfcmpgt,pfmax,pfrcpit1		;424,425,426,427,428,429,430,431
idm pfrsqit1,pfcmpeq,pfmul,pfrcpit2,pmulhrw,pi2fw,pi2fd,pf2iw		;432,433,434,435,436,437,438,439
idm pf2id,pfnacc,pfpnacc,pfsub,pfadd,pfsubr,pfacc,pswapd			;440,441,442,443,444,445,446,447
idm pavgusb,fadd,fmul,fcom,fcomp,fsub,fsubr,fdiv					;448,449,450,451,452,453,454,455
idm fdivr,fld,fst,fstp,fldenv,fldcw,fnstenv,fstenv					;456,457,458,459,460,461,462,463
idm fnstcw,fstcw,fxch,fnop,fchs,fld1,f2xm1,fprem					;464,465,466,467,468,469,470,471
idm fabs,fldl2t,fyl2x,fyl2xp1,fldl2e,fptan,fsqrt,fldpi				;472,473,474,475,476,477,478,479
idm fpatan,fsincos,ftst,fldlg2,fxtract,frndint,fxam,fldln2			;480,481,482,483,484,485,486,487
idm fprem1,fscale,fldz,fdecstp,fsin,fincstp,fcos,fiadd				;488,489,490,491,492,493,494,495
idm fimul,ficom,ficomp,fisub,fisubr,fidiv,fidivr,fcmovb				;496,497,498,499,500,501,502,503
idm fcmove,fcmovbe,fcmovu,fucompp,fild,fisttp,fist,fistp			;504,505,506,507,508,509,510,511
idm fcmovnb,fcmovne,fcmovnbe,fcmovnu,fucomi,fcomi,fnclex,fclex		;512,513,514,515,516,517,518,519
idm fninit,finit,frstor,fnsave,fsave,fnstsw,fstsw,ffree				;520,521,522,523,524,525,526,527
idm fucom,fucomp,faddp,fmulp,fsubrp,fsubp,fdivrp,fdivp				;528,529,530,531,532,533,534,535
idm fcompp,fbld,fbstp,fucomip,fcomip,ins,scas,outs					;536,537,538,539,540,541,542,543
idm loopnz,loopnzd,loopnzw,loop,loopd,loopw,cmps,xlatb				;544,545,546,547,548,549,550,551
idm prefetchw,lods,stos,getsec,retnw,retnd,enterw,enterd			;552,553,554,555,556,557,558,559
idm leavew,leaved,vmread,vmwrite,vmcall,vmlaunch,vmresume,vmxoff	;560,561,562,563,564,565,566,567
idm vmptrld,vmptrst,vmclear,vmxon,invept,invvpid,xgetbv,xsetbv		;568,569,570,571,572,573,574,575
idm xsave64,xsave,xrstor64,xrstor,pshufb,phaddw,phaddd,phaddsw		;576,577,578,579,580,581,582,583
idm pmaddubsw,phsubw,phsubd,phsubsw,psignb,psignw,psignd,pmulhrsw	;584,585,586,588,589,590,591,592
idm pblendvb,blendvps,blendvpd,ptest,pabsb,pabsw,pabsd,pmovsxbw		;593,594,595,596,597,598,599,600
idm pmovsxbd,pmovsxbq,pmovsxwd,pmovsxwq,pmovsxdq,pmuldq,pcmpeqq,movntdqa	;601,602,603,604,605,606,607,608
idm packusdw,pmovzxbw,pmovzxbd,pmovzxbq,pmovzxwd,pmovzxwq,pmovzxdq,pcmpgtq	;609,610,611,612,613,614,615,616
idm pminsb,pminsd,pminuw,pminud,pmaxsb,pmaxsd,pmaxuw,pmaxud					;617,618,619,620,621,622,623,624
idm pmulld,phminposuw,aesimc,aesenc,aesenclast,aesdec,aesdeclast,movbe		;625,626,627,628,629,630,631,632
idm crc32,roundps,roundpd,blendps,blendpd,pblendw,aeskeygen,dpps			;633,634,635,636,637,638,639,640
idm dppd,mpsadbw,pclmulqdq,pcmpestrm,pcmpestri,pcmpistrm,pcmpistri,roundss	;641,642,643,644,645,646,647,648
idm roundsd,palignr,pextrb,pextrq,pextrd,extractps,pinsrb,insertps			;649,650,651,652,653,654,655,656
idm pinsrq,pinsrd,cmpeqpd,cmpltpd,cmplepd,cmpunordpd,cmpneqpd,cmpnltpd		;657,658,659,660,661,662,663,664
idm cmpnlepd,cmpordpd,cmpeqps,cmpltps,cmpleps,cmpunordps,cmpneqps,cmpnltps
idm cmpnleps,cmpordps,cmpeqss,cmpltss,cmpless,cmpunordss,cmpneqss,cmpnltss
idm cmpnless,cmpordss,cmpeqsd,cmpltsd,cmplesd,cmpunordsd,cmpneqsd,cmpnltsd
idm cmpnlesd,cmpordsd,fxrstor64,fxrstor
idm jmpe

enum MACRO Consts:VARARG 
%   FOR parm,<Consts>
   %   parm equ curr_id
       curr_id=curr_id+1
    ENDM
ENDM

curr_id=1
enum       Ib,      Iz,       Iw,        Ub,       Sb,      Uw,          _CL,            Iv
enum       Eb,      Ew,       Ed
enum       Ev,     _Eq,     Ed_q,        Gb,       Gw,      Gd,           Gv,            Gz
enum     Gd_q,     Vps,      Vss,       Vsd,     VRps,    VRpd,          VRq,          VRdq
enum      Vpd,      Vq,      Vdq,      Vd_q,   Vdq_sd,  Vdq_ss,          Wps,           Wpd
enum      Wss,     Wsd,       Ww,        Wd,       Wq,     Wdq,           Pd,            Pq
enum     Pd_q,      Qd,       Qq,       PRq, mem80dec, m32real,      m64real,     mem80real
enum   m16int,  m32int,   m64int,       m16,        M,      Ma,           Mp,            Mb
enum       Mw,      Md,       Mq,        Mv,       Ms,     Mdq,       Mq_Mdq, Mq_VRqDifMnem
enum     Md_q,      Rv,     Rd_q,     Mw_Rv,    Mw_Rd,   Mb_Rd,      Mb_Rd_q,            Sw
enum     Cd_q,    Dd_q,      st0,       st1,      st2,     st3,          st4,           st5
enum      st6,     st7, env14_28, env98_108,       Ob,      Ov,           Ap,           _Jz
enum      _Jb,      Yb,       Xb,        Yz,       Xz,      Yv,           Xv,        rAX_r8
enum   rCX_r9, rDX_r10,  rBX_r11,   rSP_r12,  rBP_r13, rSI_r14,      rDI_r15,        AL_r8b
enum   CL_r9b, DL_r10b,  BL_r11b,   AH_r12b,  CH_r13b, DH_r14b,      BH_r15b,          _rAX
enum     _eAX,    _eCX,     _eDX,      _eBX,     _eSP,    _eBP,         _eSI,          _eDI
enum      _AL,     _AX,      _DX,       _ES,      _CS,     _SS,          _DS,           _FS
enum      _GS,     One,       xb,  UnkModRM

curr_id=1
enum      ibasic, icmpxchgxb,    icmovcc,i3dprefetch,   iclflush,     imovbe,     icrc32,  iprefetch
enum   ilongmode, ipclmulqdq,       iaes, ixsaverstr, i64sysctrl,       itsc,    irdtscp,   irdwrmsr
enum isyscallret, ienterexit,       isvm,   isysctrl,  iisysctrl,       isse, issemmxext, issemmxbsc
enum     issemmx,  issebasic,ifxsaverstr,      isse2,   isse2mmx, ibasicsse2,isse2mmxext, isse2basic
enum       isse3,   isse3mmx,   isse3fpu,     issse3,issse3mmxex,     isse4a,     isse41,  isse41bsc
enum      isse42,       immx,    immxx87,  immxbasic,       ix87, ix87cmovcc,    ix87mmx,     i3dnow
enum   i3dnowx87,  i3dnowext,       ivmx